<template>
  <div>
    <div>
      <el-breadcrumb separator-class="el-icon-arrow-right">
        <el-breadcrumb-item :to="{ path: '/home' }">首页</el-breadcrumb-item>
        <el-breadcrumb-item>商品管理</el-breadcrumb-item>
        <el-breadcrumb-item>商品列表</el-breadcrumb-item>
      </el-breadcrumb>
    </div>
    <!-- 卡片视图 -->
    <el-card>
        <el-row :gutter="20">
            <el-col :span="10">
                <el-input 
                    placeholder="请输入内容"
                    v-model="queryInfo.query"
                    clearable
                    @change="getGoodsList"
                    @clear="getGoodsList"
                >
                    <el-button 
                        slot="append" 
                        icon="el-icon-search"
                        @click="getGoodsList"
                    ></el-button>
                </el-input>
            </el-col>
            <el-col :span="4">
                <el-button type="primary" @click="dialogVisible = true">添加商品</el-button>
            </el-col>
        </el-row>

        <el-table 
        :data="goodsList"
        border
        stripe
        >
            <el-table-column 
            label="序号"
            width="80"
            type="index">
            </el-table-column>
            <el-table-column
                prop="goods_name"
                label="商品名称"
                width="300">
            </el-table-column>
            <el-table-column
                prop="goods_price"
                label="商品价格（元）"
                width="180">
            </el-table-column>
            <el-table-column
                prop="goods_weight"
                label="商品重量"
                width="180">
            </el-table-column>
            <el-table-column
                prop="add_time"
                label="创建日期"
                width="180">
            </el-table-column>
            <el-table-column
                prop=""
                label="操作"
                width="200"
            >
                <template slot-scope="scope">
                    <!-- 修改按钮 -->
                    <el-tooltip 
                    class="item" 
                    effect="dark" 
                    content="修改" 
                    placement="bottom-start">
                        <el-button 
                        type="primary" 
                        icon="el-icon-edit" 
                        size="mini"
                        @click="showUserFrom(scope.row.id)"
                        ></el-button>
                    </el-tooltip>
                    <!-- 删除按钮 -->
                    <el-tooltip class="item" effect="dark" content="删除" placement="bottom">
                        <el-button 
                        type="danger" 
                        icon="el-icon-delete" 
                        size="mini"
                        @click="removeUser(scope.row.id)"
                        ></el-button>
                    </el-tooltip>
                </template>
            </el-table-column>
        </el-table>

        <!-- 分页 -->
        <el-pagination
            @size-change="handleSizeChange"
            @current-change="handleCurrentChange"
            :current-page="queryInfo.pagenum"
            :page-sizes="[1, 2, 5, 10]"
            :page-size="queryInfo.pagesize"
            layout="total, sizes, prev, pager, next, jumper"
            :total="total"
            >
        </el-pagination>
    </el-card>
    <!-- 弹框组件 -->
    <!-- <el-dialog
        title="添加商品"
        :visible.sync="dialogVisible"
        width="50%"
        @close="closeDialog"
        >
            <el-form :model="ruleForm" :rules="rules" ref="ruleFormRef" label-width="80px">
                <el-form-item label="用户名" prop="username">
                    <el-input type="text" v-model="ruleForm.username"></el-input>
                </el-form-item>
                <el-form-item label="密码" prop="password">
                    <el-input type="password" v-model="ruleForm.password"></el-input>
                </el-form-item>
                <el-form-item label="邮箱" prop="email">
                    <el-input type="text" v-model="ruleForm.email"></el-input>
                </el-form-item>
                <el-form-item label="手机" prop="mobile">
                    <el-input type="text" v-model="ruleForm.mobile"></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="dialogVisible = false">取 消</el-button>
                <el-button type="primary" @click="addUser">确 定</el-button>
            </span>
    </el-dialog>
    
    <el-dialog
        title="修改用户信息"
        :visible.sync="userUpdateFrom"
        width="50%"
        @close="closeEditFrom"
        >
            <el-form :model="editFrom" :rules="editFromRules" ref="editFromRef" label-width="80px">
                <el-form-item label="用户名" prop="username">
                    <el-input type="text" v-model="editFrom.username" disabled></el-input>
                </el-form-item>
                <el-form-item label="邮箱" prop="email">
                    <el-input type="text" v-model="editFrom.email"></el-input>
                </el-form-item>
                <el-form-item label="手机" prop="mobile">
                    <el-input type="text" v-model="editFrom.mobile"></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="userUpdateFrom = false">取 消</el-button>
                <el-button type="primary" @click="editUser">确 定</el-button>
            </span>
    </el-dialog> -->

  </div>
</template>

<script>
export default {
    data(){
        return{
            // 获取用户列表参数对象
            queryInfo: {
                query: '',
                pagenum: 1,
                pagesize: 10
            },
            goodsList: [],
            total: 0
            
        }
    },
    created(){
        this.getGoodsList()
    },
    methods:{
        async getGoodsList() {
            const { data:res } = await this.$http.get(`/goods`, {params: this.queryInfo})
            console.log('^^^^^^^^^^^^^^^^^^^^^^', res)
            if(res.meta.status !== 200 ) return this.$message.error("获取用户列表失败");
            this.goodsList = res.data.goods
            this.total = res.data.total
        },
        // 监听分页数据
        handleSizeChange(newSzie){
            // console.log(newSzie);
            this.queryInfo.pagesize = newSzie
            this.getGoodsList()
        },
        // 监听页码只改变事件
        handleCurrentChange(newPage){
            // console.log(newPage);
            this.queryInfo.pagenum = newPage
            this.getGoodsList()
        },
        // 根据id删除用户
        async removeUser(id){
            const res = await this.$confirm(
                "确定要删除用户吗?", 
                '提示', 
                {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
                },
                console.log(res)
            ).catch( err => err)  //省略return需要省略{}
            
            // confirm确认   cancle取消
            if(res !== "confirm") {
                return this.$message.info("已取消删除")
            } else {
                const {data:delUser} = await this.$http.delete('users/' + id)
                if(delUser.meta.status !== 200) return this.$message.error("删除失败")
                this.$message.success("删除成功")
                this.getUserList()
            }
        }
    }
}
</script>

<style scoped>

</style>